#!/usr/bin/env python3
import pyfirmata
import numpy as np
import cv2
import time
if __name__ == '__main__':
    board = pyfirmata.Arduino('COM3')
    print("Communication Successfully started")

time.sleep(1)
time.sleep(1)
        

# multiple cascades: https://github.com/Itseez/opencv/tree/master/data/haarcascades

#https://github.com/Itseez/opencv/blob/master/data/haarcascades/haarcascade_frontalface_default.xml
face_cascade = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')
#https://github.com/Itseez/opencv/blob/master/data/haarcascades/haarcascade_eye.xml
eye_cascade = cv2.CascadeClassifier('haarcascade_eye.xml')
mouthCascade = cv2.CascadeClassifier('haarcascade_mouth.xml')

cap = cv2.VideoCapture(0)

while 1:
    ret, img = cap.read()
    gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
    faces = face_cascade.detectMultiScale(gray, 1.3, 4)

    for (x,y,w,h) in faces:
        cv2.rectangle(img,(x,y),(x+w,y+h),(0,255,0),10)
        roi_gray = gray[y:y+h, x:x+w]
        roi_color = img[y:y+h, x:x+w]
        
        if print("Found {0} face!".format(len(faces))):
                board.digital[13].write(1)
        else:
                board.digital[13].write(0)
        
       
        eyes = eye_cascade.detectMultiScale(roi_gray)
        for (ex,ey,ew,eh) in eyes:
            cv2.rectangle(roi_color,(ex,ey),(ex+ew,ey+eh),(255,0,0),5)

        mouth = mouthCascade.detectMultiScale(roi_gray)
        for (ex,ey,ew,eh) in mouth:
            cv2.rectangle(roi_color,(ex,ey),(ex+ew,ey+eh),(0,0,255),2)
            

    cv2.imshow('img',img)
    board.digital[13].write(0)
    k = cv2.waitKey(30) & 0xff
    if k == 27:
        break
                
cap.release()
cv2.destroyAllWindows()
